require "fahrenheit/search_request"
require "yahm"

class Fahrenheit::Ubpb::Primo::SearchRequestFactory
  
  # http://blog.sidu.in/2007/12/rubys-new-as-factory.html
  def self.new(object)
    Fahrenheit::SearchRequest.new(apply_mapping(object.to_h))
  end

  #
  private
  #
  @@search_request_mapping = Yahm::Mapping.new do
    # translate field names
    map "/**[query_string?]", to: (lambda do |query_strings, _|
      query_strings.each do |query_string|
        query_string["query_string"]["fields"].map! do |field|
          case field
            when "created"    then "cdate"
            when "identifier" then ["isbn", "issn", "lsr05", "lsr10", "lsr15"]
            when "publisher"  then "lsr34"
            when "subject"    then "sub"
            else field
          end
        end.flatten!
      end
    end)
  end

  def self.apply_mapping(hash)
    alterable_hash = deep_copy_object(hash)
    apply_mapping!(alterable_hash)
    alterable_hash
  end

  def self.apply_mapping!(hash)
    @@search_request_mapping.apply_to(hash)
  end

  def self.deep_copy_object(object)
    Marshal.load(Marshal.dump(object))  
  end

end
