require "fahrenheit/search_result"
require "yahm"

class Fahrenheit::Ubpb::Primo::SearchResultFactory
  # http://blog.sidu.in/2007/12/rubys-new-as-factory.html
  def self.new(hash)
    Fahrenheit::SearchResult.new(apply_mapping(hash))
  end

  #
  private
  #
  @@hit_mapping = Yahm::Mapping.new do
    map "/_source/primonmbib/record/display/creationdate", to: "/created"
    map "/_source/primonmbib/record/display/creator", to: "/creator"
    map "/_source/primonmbib/record/display/edition", to: "/edition"
    map [
      "/_source/primonmbib/record/control/recordid",
      "/_source/primonmbib/record/search/lsr05",
      "/_source/primonmbib/record/search/lsr10"
    ], to: "/identifier", processed_by: lambda { |fields|
      result = []
      
      fields.each_pair do |key, value|
        case key
          when /lsr05/ then result.push(value => "hbz_id")
          when /lsr10/ then result.push(value => "signature")
          when /recordid/ then result.push(value => "record_id")
        end
      end

      result.length == 1 ? result.first : result
    }
    map "/_source/primonmbib/record/display/lds02", to: "/title"
  end
  
  def self.apply_mapping(hash)
    hash["hits"]["hits"].map! { |hit| hit.merge @@hit_mapping.apply_to(hit) }
    hash
  end
end
